【ZOJ3956 The 17th Zhejiang University Programming Contest I】【01背包】Course Selection System 公式最大化

Course Selection System

Time Limit: 1 Second       Memory Limit: 65536 KB

There are n courses in the course selection system of Marjar University. The i-th course is described by two values: happiness Hi and credit Ci. If a student selects m courses x1x2, ..., xm, then his comfort level of the semester can be defined as follows:

$$(\sum_{i=1}^{m} H_{x_i})^2-(\sum_{i=1}^{m} H_{x_i})\times(\sum_{i=1}^{m} C_{x_i})-(\sum_{i=1}^{m} C_{x_i})^2$$

Edward, a student in Marjar University, wants to select some courses (also he can select no courses, then his comfort level is 0) to maximize his comfort level. Can you help him?

Input

There are multiple test cases. The first line of input contains an integer T, indicating the number of test cases. For each test case:

The first line contains a integer n (1 ≤ n ≤ 500) -- the number of cources.

Each of the next n lines contains two integers Hi and Ci (1 ≤ Hi ≤ 10000, 1 ≤ Ci ≤ 100).

It is guaranteed that the sum of all n does not exceed 5000.

We kindly remind you that this problem contains large I/O file, so it's recommended to use a faster I/O method. For example, you can use scanf/printf instead of cin/cout in C++.

Output

For each case, you should output one integer denoting the maximum comfort.

Sample Input
2
3
10 1
5 1
2 10
2
1 10
2 10
Sample Output
191
0
Hint

For the first case, Edward should select the first and second courses.

For the second case, Edward should select no courses.


Author:  WANG, Yucheng

Source: The 17th Zhejiang University Programming Contest Sponsored by TuSimple

#include<stdio.h>
#include<iostream>
#include<string.h>
#include<string>
#include<ctype.h>
#include<math.h>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<bitset>
#include<algorithm>
#include<time.h>
using namespace std;
void fre() { freopen("c://test//input.in", "r", stdin); freopen("c://test//output.out", "w", stdout); }
#define MS(x, y) memset(x, y, sizeof(x))
#define ls o<<1
#define rs o<<1|1
typedef long long LL;
typedef unsigned long long UL;
typedef unsigned int UI;
template <class T1, class T2>inline void gmax(T1 &a, T2 b) { if (b > a)a = b; }
template <class T1, class T2>inline void gmin(T1 &a, T2 b) { if (b < a)a = b; }
const int N = 505, M = 0, Z = 1e9 + 7, inf = 0x3f3f3f3f;
template <class T1, class T2>inline void gadd(T1 &a, T2 b) { a = (a + b) % Z; }
int casenum, casei;
int f[N * 105];
int n;
int main()
{
	scanf("%d", &casenum);
	for (casei = 1; casei <= casenum; ++casei)
	{
		MS(f, -1); f[0] = 0;
		scanf("%d", &n);
		int top = 0;
		for (int i = 1; i <= n; ++i)
		{
			int h, c;
			scanf("%d%d", &h, &c);
			top += c;
			for (int j = top; j >= c; --j)if(f[j - c] != -1)
			{
				gmax(f[j], f[j - c] + h);
			}
		}
		LL ans = 0;
		for (int i = 0; i <= top; ++i)if(f[i] != -1)
		{
			LL H = f[i];
			LL C = i;
			gmax(ans, H * (H - C) - C * C);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
/*
【trick&&吐槽】
<1> 写成完全背包了>.<
<2> 因为求值的特殊性,我们不需要把f[]初始化为-1,但是初始化的基础最好还是有想到的

【题意】
选择若干个数{h[i], c[i]}
H设为这些数的∑h[]
C设为这些数的∑c[]
我们想要使得H * H - H * C - C * C);

【分析】
题目当然是使得H * (H - C) - C * C尽可能大。
而显然,我们必要使得H > C才能得到非负解
而H越大,答案越大,C越小,答案越大。
于是可以固定C,最大化H。这个可以使用背包实现。

【时间复杂度&&优化】
O(n * 100 * n) = 25e6

*/


评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值